/* $Id$ */
#if !defined DBOARD_H
#define DBOARD_H

#include <X11/Xlib.h>
#include <X11/Xresource.h> /* Xrm* */

#define SCREEN_RGB_CIMAX 3
#define SCREEN_RGB_IMAX  256

enum cursorShape {
  CURSOR_WAIT,
  CURSOR_MAX
};

typedef struct dBoard DBoard;
typedef int Handler(DBoard *board, XEvent *event, int *pdone, void *data);
typedef int Processor(DBoard *board, int *pdone, void *data);

struct dBoard {
  Display *display;
  Window window;
  GC gc;
  Pixmap pixmap;
  int width;
  int height;
  unsigned long screen_rgb[SCREEN_RGB_CIMAX][SCREEN_RGB_IMAX];
  int bits_per_pixel;
  Cursor cursor[CURSOR_MAX];
  XrmDatabase resource;
  Handler *handler;
  Processor *processor;
};

DBoard *dBoard_open(int *argc, char **argv);
void dBoard_get_attributes(DBoard *board, int *depth, int *width, int *height, unsigned long *background);
void dBoard_set_name(DBoard *board, const char *name);
void dBoard_show(DBoard *board);
int dBoard_close(DBoard *board);
int dBoard_main(DBoard *board, void *data);
int dBoard_flush(DBoard *board);
void dBoard_reset(DBoard *board, int width, int height);
void dBoard_copy(DBoard *board);
void dBoard_define_cursor(DBoard *board, enum cursorShape shape);
void dBoard_undefine_cursor(DBoard *board);
int dBoard_setHandler(DBoard *board, Handler *handler, long event_mask);
void dBoard_setProcessor(DBoard *board, Processor *processor);

#endif /* DBOARD_H */
